/*
 * gnome-login-support.c:
 *
 * Author:
 *    Miguel de Icaza (miguel@gnu.org)
 *
 *
 */
#include <config.h>
#include <unistd.h>
#include <errno.h>
#include "gnome-login-support.h"

int
n_read (int fd, void *buf, int count)
{
	int n = 0, i;
	char *buffer;

	buffer = (char*) buf;
	while (n < count) {
		i = read (fd, buffer + n, count - n);
		switch (i) {
		case -1:
			switch (errno) {
			case EINTR:
			case EAGAIN:
#ifdef ERESTART
			case ERESTART:
#endif
				/* suppress these errors */
				break;
			default:
				return -1;
				break;
			}
			break;
		case 0:
			return n;
			break;
		default:
			n += i;
			break;
		}
	}

	return n;
}

int
n_write (int fd, const void *buf, int count)
{
	int n = 0, i;
	const char *buffer;

	buffer = (char*) buf;
	while (n < count) {
		i = write (fd, buffer + n, count - n);
		switch (i) {
		case -1:
			switch (errno) {
			case EINTR:
			case EAGAIN:
#ifdef ERESTART
			case ERESTART:
#endif
				/* suppress these errors */
				break;
			default:
				return -1;
				break;
			}
			break;
		case 0:
			return n;
			break;
		default:
			n += i;
			break;
		}
	}

	return n;
}
